// Напишите как вы понимаете рекурсию. Для чего она используется на практике?

// Задание
// Реализовать функцию подсчета факториала числа. 
// Технические требования:

// Считать с помощью модального окна браузера число, которое введет пользователь.
// С помощью функции посчитать факториал числа, которое ввел пользователь, и вывести его на экран.
// Использовать синтаксис ES6 для работы с перемеными и функциями.


// Необязательное задание продвинутой сложности:

// После ввода данных добавить проверку их корректности. Если пользователь не ввел число, 
// либо при вводе указал не число, - спросить число заново (при этом значением по умолчанию 
// для него должна быть введенная ранее информация).



let num;
do {
    num = +prompt('Enter your number');
} while (num === null || isNaN(num))

function factorial(num) {
    if (num === 1) {
        return num;
    } else {
        return num * factorial(num - 1);
    }
}
console.log(factorial(num));

// Рекурсия - вызов функции внутри себя. Рекурсию можно использовать как альтернативу
// циклам для читаемости кода.